var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\" />\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"Content-Style-Type\" content=\"text/css\" /><meta name=\"generator\" content=\"pandoc\" /><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" /><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Troubleshoot GLSL shaders</title>\n\
   </head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Troubleshoot GLSL shaders</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"troubleshoot-glsl-shaders\"></a></div>\n\
<div class=\'section\'><a id=\"problem\"></a><h2 id=\"problem\">Problem</h2></div>\n\
<p>When loading an <span class=\'code\'>.ogsfx</span> shader instance via <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsFileShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a581c659670f0e3168750382c61a91a25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#a1baace207989b925d235d19e394df576&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsFileShader()</a></span> or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsBufferShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#ad99e1c36c00ccaf3ea0c7fe0599557f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#a9ecc5c0caef38661351a32c3338b2438&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsBufferShader()</a></span>, the shader is not rendered in the viewport, and no error appears.</p>\n\
<p>How can I obtain shader compile errors?</p>\n\
<div class=\'section\'><a id=\"solution\"></a><h2 id=\"solution\">Solution</h2></div>\n\
<p>When loading <span class=\'code\'>.ogsfx</span> shaders, errors occur at bind time rather than at creation time when <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsFileShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a581c659670f0e3168750382c61a91a25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#a1baace207989b925d235d19e394df576&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsFileShader()</a></span> is called. Call <span class=\'code\'>MShaderInstance.bind()</span> to bind the shader instance to the draw context, then call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a32aa7a2b395ae162d8fc66abf5f5a14a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#ae0051d8ad53d1231615f3a1ae93d9785&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastError()</a></span> or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastErrorSource()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a45e7598b79e4e7202aa4082baec16231&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#a942bb797f95fd59e54fa664f9a0eabf3&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastErrorSource()</a></span> to report the effect compile errors.</p>\n\
<p>Alternatively, you can set the following pragma in the shader so that errors occur at creation time:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma FullCompileOnLoad:true; \n\
</pre></div><p>You must then call <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a32aa7a2b395ae162d8fc66abf5f5a14a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#ae0051d8ad53d1231615f3a1ae93d9785&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastError()</a></span> or <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastErrorSource()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a45e7598b79e4e7202aa4082baec16231&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_manager.html#a942bb797f95fd59e54fa664f9a0eabf3&quot;,&quot;title&quot;:&quot;Python 2.0 API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastErrorSource()</a></span> to report the effect compile errors.</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";